//   KABLOSUZ ODA TERMOSTATI v1.0 (VER?C? KISIM)
//   
//  Yazan: Tamer Sava?c?
//  Tarih: 27.01.2017
// 
//  Bu kod, arduinoya ba?l? DHT11 sensr ile llen s?cakl???n nRF24 ile kablosuz olarak, kombinin oda termostat? kprsne bir rle ile ba?lanan ba?ka bir arduinoya
//  aktar?lmas? iin yaz?lm??t?r.
//  
//  email: tsavasci@yahoo.com



#include <dht11.h>                              // dht11 ktphanesini eklendi.
#define DHT11PIN 2                              // DHT11PIN olarak Dijital 2 belirlendi
#include <SPI.h>                                // SPI ileti?im ktphanesi eklendi
#include <nRF24L01p.h>                          // Kablosuz ileti?im ktphanesi eklendi
#include <LiquidCrystal.h>                      // LCD ktphanesi eklendi
LiquidCrystal lcd(3, 4, 5, 6, 10, A0);          // LCD pinleri tan?mland?
nRF24L01p verici(7, 8);                         // CSN = 7, CE = 8 olarak belirlendi
float sicaklik;                                 // kombiye iletilecek "s?cakl?k" de?i?keni tan?mland?
dht11 DHT11;                                    // DHT11 ba?lat?ld?

void setup()
{
  Serial.begin(9600);
  SPI.begin();
  SPI.setBitOrder(MSBFIRST);                    // SPI ba?lat?ld?
  verici.channel(90);
  verici.TXaddress("Tamer");                    // ileti?im kanal?na isim verildi.
  verici.init();                                // Verici ayarlar? yap?ld?
  lcd.begin(16, 2);
  lcd.setCursor(0, 0);
}

void loop()
{
  int chk = DHT11.read(DHT11PIN);               // chk de?i?keni tan?mland?. Bu de?i?ken DHT11 in do?ru lm yap?p yapmad???n? kontrol etmemizi sa?layacak. lm do?ru ise de?eri "0" d?r 
  Serial.println();
  Serial.print("Nem (%): ");
  Serial.println((float)DHT11.humidity, 2);     // Nem de?eri okutuldu
  Serial.print("Sicaklik (Celcius): ");
  Serial.println((float)DHT11.temperature, 2);  // S?cakl?k de?eri okutuldu 
  Serial.println(chk);                          // Sensrn okunup okunmad???n? konrol ediyoruz. Sonuc 0 dan farkl? ise ba?lant?lar? kontrol edin. 
  sicaklik = DHT11.temperature, 2;              // s?cakl?k de?i?keninin de?eri DHT11 den gelen s?cakl?k verisi olarak tan?mland?. 
  verici.txPL(sicaklik);                        // s?cakl?k verisi kombiye gnderilmek zere nRF24L01'e aktar?ld?
  boolean gonderimDurumu = verici.send(FAST);   // Bilgi gnderimi kontrol edildi. 

  if (gonderimDurumu == true)                   // E?er gnderim ba?ar?s?z olursa gonderimDurumu'nun de?eri false olacakt?r
  {
    Serial.println("mesaji gonderildi");        // Debugging iin mesaj?n gnderim durumu seri monitre yazd?r?ld?. 
    
    lcd.clear();                                // LCD temizlendi 
    lcd.setCursor(0, 0);                        // LCD kursor pozisyonu ayarland?
    lcd.print("Gonderildi..");                  // Gnderim durumu LCD ye yazd?r?ld?         
    lcd.setCursor(0, 1);                        // LCD alt sat?r?na geildi
    lcd.print(chk);                             // DHT11 in chk de?eri yazd?r?ld?. (0 dan farkl? ise hatal? lm yap?yor demektir.
    delay(3000);                                // 3 saniye bu de?erler ekranda kald?
    lcd.clear();                                // LCD tekrar temizlendi 
    lcd.setCursor(0, 0);                        // LCD kursor pozisyonu ayarland?
    lcd.print("Nem %   : ");                    // DHT11 sensrnn okudu?u nem de?er LCD ye yazd?r?ld?. 
    lcd.print((float)DHT11.humidity);
    lcd.setCursor(0, 1);                        // LCD kursor pozisyonu ayarland?
    lcd.print("Sicaklik: ");                    // DHT11 sensrnn okudu?u s?cakl?k de?er LCD ye yazd?r?ld?.
    lcd.print((float)DHT11.temperature + 3);
  }
  else
  {
    Serial.println("mesaji gonderilemedi");
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Gonderilemedi.");
    lcd.setCursor(0, 1);
    lcd.print(chk);
    delay(3000);
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Nem %   : ");
    lcd.print((float)DHT11.humidity);
    lcd.setCursor(0, 1);
    lcd.print("Sicaklik: ");
    lcd.print((float)DHT11.temperature + 3);
  }
  delay(120000);                              // Kararl? lm iin 2 dakika beklendi. 2 dakikada bir kombiye oda s?cakl??? iletilecek. 
}